require('fogcache_auth')
require('json_helper')

local function debug(A, B, C, D) end

fogcache_update_request = {}

function fogcache_update_request.handleRequest(Data)

   iguana.stopOnError(false)
   
   local Request = net.http.parseRequest{data=Data}
   
   local User, Password = fogcache_auth.authUserPassword(Request)
   
   if Request.get_params.User then
      User = Request.get_params.User
   end
   if Request.get_params.Password then
      Password = filter.hex.dec(Request.get_params.Password)
   end
   
   local Headers = {}
   
   local PasswordDatabase = json_helper.loadJsonFileSafe('PasswordDatabase.json', '{}')
   local PasswordHash = json_helper.getJsonValue(PasswordDatabase, User, '')
   
   if not User or not PasswordHash or util.md5(Password) ~= PasswordHash then
      fogcache_auth.respondAuthRequired()
      return
   end
    
   local PageId = Request.get_params.PageId
   local QueryString = 'FetchPageId='..PageId
   debug('QueryString:', QueryString)
   queue.push{data=QueryString}

   local Body = ''
   Body = Body .. 'Enqueued Page Id '..PageId
   debug(Body)
   
   local Response = net.http.respond{entity_type='text/html', body=Body, headers=Headers}
   debug(Response)
end
